clear; clc; close all;

%% PASSO 1: gera o sinal
Fs = 20000; %taxa de aquisicao do sistema digital
Ts = 1/Fs;
n=0:19999; %vou analisar 20 mil amostras (ou seja, 1 segundo de amostragem do sistema considerando o valor de Fs)
t = n*Ts;
x = EQUACAO PARA SINAL X AQUI.

%% PASSO 2: projeta os coeficientes dos filtros. Sao dois filtros no caso. Filtro 1 e 2. 
% passo 2.1: projeta filtro 1 FIR (nao realimentado)
[n,fo,ao,w] = firpmord([1000  3000 ],[1 0 ],[0.05 0.1 ],Fs); 
b1 = firpm(n,fo,ao,w);
a1 = [1];
figure; freqz(b1,a1,1000, Fs); title('sistema 1 FIR');

% passo 2.2: projeta filtro 2 IIR (realimentado)
wp= 1000/(Fs/2);
ws= 3000/(Fs/2);
[n, wn]=buttord(wp, ws, 0.44, 20);  %0.44db=0.05 em escala linear e 20dB=0.1 em escala linear
[b2, a2]= butter(n,wn);
figure; freqz(b2, a2, 1000, Fs); title('sistema 2 IIR');

%% PASSO 3: a partir daqui o estudante
figure;
